from datetime import datetime

from cpl_core.database import TableABC


class SteamSpecialOffer(TableABC):
    def __init__(
        self,
        name: str,
        original_price: float,
        discount_price: float,
        discount_pct: int,
        created_at: datetime = None,
        modified_at: datetime = None,
        id=0,
    ):
        self._id = id
        self._name = name
        self._original_price = original_price
        self._discount_price = discount_price
        self._discount_pct = discount_pct

        TableABC.__init__(self)
        self._created_at = created_at if created_at is not None else self._created_at
        self._modified_at = modified_at if modified_at is not None else self._modified_at

    @property
    def id(self) -> int:
        return self._id

    @property
    def name(self) -> str:
        return self._name

    @name.setter
    def name(self, value: str):
        self._name = value

    @property
    def original_price(self) -> float:
        return self._original_price

    @original_price.setter
    def original_price(self, value: float):
        self._original_price = value

    @property
    def discount_price(self) -> float:
        return self._discount_price

    @discount_price.setter
    def discount_price(self, value: float):
        self._discount_price = value

    @property
    def discount_pct(self) -> int:
        return self._discount_pct

    @discount_pct.setter
    def discount_pct(self, value: int):
        self._discount_pct = value

    @staticmethod
    def get_select_all_string() -> str:
        return str(
            f"""
            SELECT * FROM `SteamSpecialOffers`;
        """
        )

    @staticmethod
    def get_select_by_name_string(name: str) -> str:
        return str(
            f"""
            SELECT * FROM `SteamSpecialOffers`
            WHERE `Game` = '{name}';
        """
        )

    @property
    def insert_string(self) -> str:
        return str(
            f"""
            INSERT INTO `SteamSpecialOffers` (
                `Game`, `OriginalPrice`, `DiscountPrice`, `DiscountPct`
            ) VALUES (
                '{self._name}',
                {self._original_price},
                {self._discount_price},
                {self._discount_pct}
            );
        """
        )

    @property
    def udpate_string(self) -> str:
        return str(
            f"""
            UPDATE `SteamSpecialOffers`
            SET `Game` = '{self._name}',
            `OriginalPrice` = {self._original_price},
            `DiscountPrice` = {self._discount_price},
            `DiscountPct` = {self._discount_pct}
            WHERE `Id` = {self._id};
        """
        )

    @property
    def delete_string(self) -> str:
        return str(
            f"""
            DELETE FROM `SteamSpecialOffers`
            WHERE `Id` = {self._id};
        """
        )
