from cpl_core.database.context import DatabaseContextABC

from bot_data.model.known_user import KnownUser
from bot_data.model.known_user_history import KnownUserHistory
from bot_graphql.abc.data_query_with_history_abc import DataQueryWithHistoryABC


class KnownUserQuery(DataQueryWithHistoryABC):
    def __init__(self, db: DatabaseContextABC):
        DataQueryWithHistoryABC.__init__(self, "KnownUser", "KnownUsersHistory", KnownUserHistory, db)

        self.set_field("id", self.resolve_id)
        self.set_field("discordId", self.resolve_discord_id)

    @staticmethod
    def resolve_id(x: KnownUser, *_):
        return x.id

    @staticmethod
    def resolve_discord_id(x: KnownUser, *_):
        return x.discord_id
